## fs-uae 2.2.3+dfsg

=== Makefile ===
include common.mk
version = $(strip $(shell cat VERSION))
series = $(strip $(shell cat SERIES))

all: fs-uae mo

cppflags = -DFSEMU -DFSUAE -D_FILE_OFFSET_BITS=64

ifeq ($(debug), 1)
cppflags += -DDEBUG
endif

#ifeq ($(wildcard libfsemu), libfsemu)
#libfsemu_dir = libfsemu
#libfsemu/out/libfsemu.a:
#	make -C libfsemu arch=$(arch)
#libfsemu-target: libfsemu/out/libfsemu.a
#else
#libfsemu_dir = ../libfsemu
#libfsemu-target:
#endif

libfsemu_dir = libfsemu
libfsemu-target:
	$(make) -C libfsemu debug=$(debug) devel=$(devel) optimize=$(optimize) \
			android=$(android)

#ifeq ($(wildcard libfs-capsimage), libfs-capsimage)
#libfs-capsimage_dir = libfs-capsimage
#libfs-capsimage/out/CAPSImg.dll:
#	make -C libfs-capsimage
#libfs-capsimage-target: libfs-capsimage/out/CAPSImg.dll
#else
#libfs-capsimage_dir = ../libfs-capsimage
#libfs-capsimage-target:
#endif

ifeq ($(android), 1)
use_glib := 0
warnings = 
errors = -Werror=implicit-function-declaration -Werror=return-type
cxxflags = $(warnings) $(errors) -Isrc/od-fs -Isrc/od-fs/include \
		-Isrc/include -Igensrc -Isrc \
		-I$(libfsemu_dir)/include \
		-Wno-write-strings -fpermissive

cflags = -std=c99 $(cxxflags)
ldflags =
libs = -L$(libfsemu_dir)/out -lfsemu -lpng -lz

else
use_glib := 1
use_freetype := 1
common_flags = -Isrc/od-fs -Isrc/od-fs/include \
		-Isrc/include -Igensrc -Isrc \
		`pkg-config --cflags glib-2.0 gthread-2.0 libpng` \
		-I$(libfsemu_dir)/include \
		-I$(libfsemu_dir)/src/lua \
		`sdl-config --cflags`
cflags = $(common_flags) -std=c99 $(CFLAGS)
#cxxflags = $(common_flags) -fpermissive $(CXXFLAGS)
cxxflags = $(common_flags) $(CXXFLAGS)
ldflags = $(LDFLAGS)
libs = -L$(libfsemu_dir)/out -lfsemu `sdl-config --libs` \
		`pkg-config --libs libpng` -lz

ifeq ($(devel), 1)
	warnings = -Wno-unused-variable -Wno-unused-function -Wno-write-strings \
			-Wno-unused-but-set-variable
	errors = -Werror=implicit-function-declaration -Werror=return-type
	cflags += $(warnings) $(errors)
	cxxflags += $(warnings) $(errors)
endif

endif

ifeq ($(use_glib), 1)
	libs += `pkg-config --libs glib-2.0 gthread-2.0`
else ifeq ($(android), 1)
else
	libs += -lrt -lpthread
endif

ifeq ($(use_freetype), 1)
	libs += `pkg-config --libs freetype2`
endif

profile_generate := 0
profile_use := 0

ifeq ($(optimize), 1)
	cflags += -O2 -ggdb
	cxxflags += -O2 -ggdb
else ifneq ($(noflags), 1)
	cflags += -O0 -ggdb
	cxxflags += -O0 -ggdb
endif

ifeq ($(profile_generate), 1)
	cflags += -fprofile-generate
	cxxflags += -fprofile-generate
	ldflags += -fprofile-generate
	libs += -lgcov
endif

ifeq ($(profile_use), 1)
	cflags += -fprofile-use
	cxxflags += -fprofile-use
endif

ifeq ($(force_32bit),1)
	cflags += -m32
	cxxflags += -m32
	ldflags += -m32
endif

#uae_warn = -Wno-unused-value -Wno-uninitialized -Wno-sign-compare
#uae_warn += -fpermissive -Wno-unused-function -Wno-format
#uae_warn +=  -Wmissing-braces -Wall -Wno-sign-compare
uae_warn = -Wall -Wno-sign-compare
generate = 0

ifeq ($(os), android)
  cppflags += -DANDROID
  cxxflags += 
  libs += -lGLESv1_CM
else ifeq ($(os), windows)
  cppflags += -DWINDOWS
  cxxflags += -U_WIN32 -UWIN32
  libs += -lOpenGL32 -lGLU32 -lgdi32 -lWinmm -lOpenAL32 -lWs2_32 -lWininet

  ifeq ($(devel), 1)
  libs += -mno-windows
  endif


else ifeq ($(os), macosx)
  uname_m := $(shell uname -m)
  ifneq ($(arch),)
  else ifneq ($(findstring i386,$(uname_m)),)
    arch = i386
  else ifneq ($(findstring Power,$(uname_m)),)
    arch = ppc
  else
    arch = x86_64
  endif
  cflags += -arch $(arch)
  cxxflags += -arch $(arch)
  ldflags += -arch $(arch) -headerpad_max_install_names
  cppflags += -DMACOSX
  libs += -framework OpenGL -framework Carbon -framework OpenAL
else ifeq ($(os), freebsd)
  cppflags += -DFREEBSD
  libs += -lGL -lGLU -lopenal -lX11 -lcompat
else ifeq ($(os), openbsd)
  cppflags += -DOPENBSD
  libs += -lGL -lGLU -lopenal -lX11 -lcompat
else
  cppflags += -DLINUX
  ldflags += -Wa,--execstack
  libs += -lGL -lGLU -lopenal -ldl -lX11
  generate = 0
endif

ifneq ($(os), android)
	cppflags += -DUSE_SDL -DUSE_GLIB -DWITH_LUA
endif

objects = \
obj/fs-uae-config.o \
obj/fs-uae-input.o \
obj/fs-uae-joystick.o \
obj/fs-uae-keyboard.o \
obj/fs-uae-luascript.o \
obj/fs-uae-main.o \
obj/fs-uae-menu.o \
obj/fs-uae-mouse.o \
obj/fs-uae-paths.o \
obj/fs-uae-uae_config.o \
obj/fs-uae-version.o \
obj/fs-uae-video.o

ifeq ($(os), windows)
objects += obj/fs-uae.res
endif

uae_objects = \
obj/gensrc-blitfunc.o \
obj/gensrc-blittable.o \
obj/gensrc-cpudefs.o \
obj/gensrc-cpuemu_0.o \
obj/gensrc-cpuemu_11.o \
obj/gensrc-cpuemu_12.o \
obj/gensrc-cpuemu_20.o \
obj/gensrc-cpuemu_21.o \
obj/gensrc-cpuemu_22.o \
obj/gensrc-cpuemu_31.o \
obj/gensrc-cpustbl.o \
obj/a2091.o \
obj/akiko.o \
obj/amax.o \
obj/ar.o \
obj/arcadia.o \
obj/aros.rom.o \
obj/audio.o \
obj/autoconf.o \
obj/blitter.o \
obj/blkdev.o \
obj/blkdev_cdimage.o \
obj/bsdsocket.o \
obj/calc.o \
obj/cd32_fmv.o \
obj/cdrom.o \
obj/cdtv.o \
obj/cia.o \
obj/cfgfile.o \
obj/consolehook.o \
obj/cpummu.o \
obj/crc32.o \
obj/custom.o \
obj/debug.o \
obj/disk.o \
obj/diskutil.o \
obj/dongle.o \
obj/drawing.o \
obj/driveclick.o \
obj/enforcer.o \
obj/ersatz.o \
obj/events.o \
obj/expansion.o \
obj/fdi2raw.o \
obj/filesys.o \
obj/fpp.o \
obj/fsdb.o \
obj/fsusage.o \
obj/gayle.o \
obj/gfxutil.o \
obj/hardfile.o \
obj/hrtmon.rom.o \
obj/identify.o \
obj/inputrecord.o \
obj/isofs.o \
obj/keybuf.o \
obj/luascript.o \
obj/main.o \
obj/memory.o \
obj/missing.o \
obj/native2amiga.o \
obj/newcpu.o \
obj/ncr_scsi.o \
obj/readcpu.o \
obj/rommgr.o \
obj/savestate.o \
obj/scsi.o \
obj/scsiemul.o \
obj/specialmonitors.o \
obj/statusline.o \
obj/traps.o \
obj/uaeexe.o \
obj/uaelib.o \
obj/uaeresource.o \
obj/uaeserial.o \
obj/zfile.o \
obj/zfile_archive.o \
obj/jit-compemu.o \
obj/jit-compemu_fpp.o \
obj/jit-compemu_support.o \
obj/jit-compstbl.o \
obj/zip-archiver-unzip.o \
obj/dms-archiver-crc_csum.o \
obj/dms-archiver-getbits.o \
obj/dms-archiver-maketbl.o \
obj/dms-archiver-pfile.o \
obj/dms-archiver-tables.o \
obj/dms-archiver-u_deep.o \
obj/dms-archiver-u_heavy.o \
obj/dms-archiver-u_init.o \
obj/dms-archiver-u_medium.o \
obj/dms-archiver-u_quick.o \
obj/dms-archiver-u_rle.o \
obj/od-fs-audio.o \
obj/od-fs-bsdsocket_host.o \
obj/od-fs-blkdev-linux.o \
obj/od-fs-caps.o \
obj/od-fs-cda_play.o \
obj/od-fs-charset.o \
obj/od-fs-clock.o \
obj/od-fs-cdimage_stubs.o \
obj/od-fs-clipboard.o \
obj/od-fs-driveclick.o \
obj/od-fs-filesys_host.o \
obj/od-fs-fsdb_host.o \
obj/od-fs-hardfile_host.o \
obj/od-fs-input.o \
obj/od-fs-inputdevice.o \
obj/od-fs-keymap.o \
obj/od-fs-libamiga.o \
obj/od-fs-logging.o \
obj/od-fs-mman.o \
obj/od-fs-parser.o \
obj/od-fs-random.o \
obj/od-fs-roms.o \
obj/od-fs-picasso96.o \
obj/od-fs-serial_host.o \
obj/od-fs-stubs.o \
obj/od-fs-support.o \
obj/od-fs-util.o \
obj/od-fs-threading.o \
obj/od-fs-uae_host.o \
obj/od-fs-uaemisc.o \
obj/od-fs-version.o \
obj/od-fs-video.o

ifeq ($(generate), 1)

gensrc/genblitter: obj/genblitter.o obj/blitops.o obj/writelog.o
	$(cxx) $(cppflags) $(cxxflags) obj/genblitter.o obj/blitops.o \
			obj/writelog.o -o gensrc/genblitter

gensrc/gencpu: gensrc/cpudefs.cpp obj/gencpu.o obj/readcpu.o obj/missing.o \
		gensrc/cpudefs.cpp
	$(cxx) $(cppflags) $(cxxflags) obj/gencpu.o obj/readcpu.o obj/missing.o \
			gensrc/cpudefs.cpp -o gensrc/gencpu

gensrc/genlinetoscr:
	$(cxx) $(cppflags) $(cxxflags) src/genlinetoscr.cpp -o gensrc/genlinetoscr

gensrc/gencomp: src/jit/gencomp.cpp obj/readcpu.o obj/gen-cpudefs.o obj/missing.o obj/writelog.o
	$(cxx) $(cppflags) $(cxxflags) src/jit/gencomp.cpp obj/readcpu.o obj/gen-cpudefs.o obj/missing.o obj/writelog.o -o gensrc/gencomp

gensrc/linetoscr.cpp: gensrc/genlinetoscr
	gensrc/genlinetoscr > gensrc/linetoscr.cpp

gensrc/blit.h: gensrc/genblitter
	gensrc/genblitter i > gensrc/blit.h

gensrc/blitfunc.cpp: gensrc/genblitter gensrc/blitfunc.h
	gensrc/genblitter f > gensrc/blitfunc.cpp

gensrc/blitfunc.h: gensrc/genblitter
	gensrc/genblitter h > gensrc/blitfunc.h

gensrc/blittable.cpp: gensrc/genblitter gensrc/blitfunc.h
	gensrc/genblitter t > gensrc/blittable.cpp

gensrc/build68k:
	$(cxx) $(cppflags) $(cxxflags) src/build68k.cpp src/writelog.cpp -o gensrc/build68k

gensrc/cpudefs.cpp: gensrc/build68k src/table68k
	./gensrc/build68k < src/table68k > gensrc/cpudefs.cpp
	#python util/fix_tchar.py gensrc/cpudefs.cpp

gensrc/cpuemu_0.cpp: gensrc/gencpu
	cd gensrc && ./gencpu --optimized-flags

gensrc/cpustbl.cpp: gensrc/cpuemu_0.cpp

gensrc/cputbl.h: gensrc/cpuemu_0.cpp

gensrc/cpuemu_11.cpp: gensrc/cpuemu_0.cpp
gensrc/cpuemu_12.cpp: gensrc/cpuemu_0.cpp
gensrc/cpuemu_20.cpp: gensrc/cpuemu_0.cpp
gensrc/cpuemu_21.cpp: gensrc/cpuemu_0.cpp
gensrc/cpuemu_31.cpp: gensrc/cpuemu_0.cpp

endif

# Using GCC optimization level O0 instead of O2 for cpuemu*, since a bug
# was found caused by the optimizer (where basically (1 ^ 0) & (1 ^ 0) was
# evaluated to 0). This fixes Tower of Babel (IPF).

obj/gensrc-cpuemu%.o: gensrc/cpuemu%.cpp
	$(cxx) $(cppflags) $(cxxflags) -O0 -c $< -o $@

obj/gensrc-%.o: gensrc/%.cpp
	$(cxx) $(cppflags) $(cxxflags) -c $< -o $@

obj/%.o: src/%.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -c $< -o $@

obj/zip-archiver-%.o: src/archivers/zip/%.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -c $< -o $@

obj/dms-archiver-%.o: src/archivers/dms/%.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -c $< -o $@

obj/jit-%.o: src/jit/%.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -c $< -o $@

obj/jit-compemu_support.o: src/jit/compemu_support.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -fpermissive -c $< -o $@

obj/bsdsocket.o: src/bsdsocket.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -fpermissive -c $< -o $@

obj/od-fs-%.o: src/od-fs/%.cpp
	$(cxx) $(cppflags) $(cxxflags) -c $< -o $@

obj/uae.a: gensrc/blit.h gensrc/linetoscr.cpp $(uae_objects)
ifeq ($(os), macosx)
	rm -f $@
endif
	$(ar) cru $@ $(uae_objects)
ifeq ($(os), macosx)
	ranlib $@
endif

obj/fs-uae.res: src/fs-uae/fs-uae.rc
	windres $< -O coff -o $@

obj/fs-uae-%.o: src/fs-uae/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

#ifeq ($(os), windows)
#out/CAPSImg.dll:
#	cp $(libfs-capsimage_dir)/out/CAPSImg.dll out/
#run_deps: out/CAPSImg.dll
#else
#run_deps:
#endif

share/locale/%/LC_MESSAGES/fs-uae.mo: po/%.po
	mkdir -p share/locale/$*/LC_MESSAGES
	msgfmt --verbose $< -o $@

catalogs = \
	share/locale/cs/LC_MESSAGES/fs-uae.mo \
	share/locale/de/LC_MESSAGES/fs-uae.mo \
	share/locale/es/LC_MESSAGES/fs-uae.mo \
	share/locale/fi/LC_MESSAGES/fs-uae.mo \
	share/locale/fr/LC_MESSAGES/fs-uae.mo \
	share/locale/it/LC_MESSAGES/fs-uae.mo \
	share/locale/nb/LC_MESSAGES/fs-uae.mo \
	share/locale/pl/LC_MESSAGES/fs-uae.mo \
	share/locale/pt/LC_MESSAGES/fs-uae.mo \
	share/locale/sr/LC_MESSAGES/fs-uae.mo \
	share/locale/tr/LC_MESSAGES/fs-uae.mo

mo: $(catalogs)

fs-uae: libfsemu-target obj/uae.a $(objects)
	rm -f out/fs-uae
	$(cxx) $(ldflags) $(objects) obj/uae.a $(libs) -o fs-uae

dist_dir := fs-uae-$(version)
dist_dir_launcher := fs-uae-launcher-$(version)

distdir-launcher-base:
	rm -Rf $(dist_dir_launcher)/*
	mkdir -p $(dist_dir_launcher)

	cp -a launcher/fs_uae_launcher $(dist_dir_launcher)/
	find $(dist_dir_launcher) -name "*.pyc" -delete
	cp -a launcher/README $(dist_dir_launcher)/
	cp -a launcher/COPYING $(dist_dir_launcher)/
	cp -a launcher/fs-uae-launcher.py $(dist_dir_launcher)/
	cp -a launcher/Makefile.mk $(dist_dir_launcher)/
	cp -a launcher/setup.py $(dist_dir_launcher)/
	cp -a launcher/setup_py2exe.py $(dist_dir_launcher)/
	cp -a launcher/setup_py2app.py $(dist_dir_launcher)/

	mkdir -p $(dist_dir_launcher)/debian
	cp -a launcher/debian/changelog $(dist_dir_launcher)/debian/
	cp -a launcher/debian/compat $(dist_dir_launcher)/debian/
	cp -a launcher/debian/control $(dist_dir_launcher)/debian/
	cp -a launcher/debian/copyright $(dist_dir_launcher)/debian/
	cp -a launcher/debian/rules $(dist_dir_launcher)/debian/
	cp -a launcher/debian/source $(dist_dir_launcher)/debian/

	mkdir -p $(dist_dir_launcher)/scripts

=== libfsemu/Makefile ===
uname := $(shell uname -a)
ifneq ($(findstring Msys,$(uname)),)
    os = windows
else ifneq ($(findstring Darwin,$(uname)),)
    os = macosx
else ifneq ($(findstring FreeBSD,$(uname)),)
    os = freebsd
else ifneq ($(findstring OpenBSD,$(uname)),)
    os = openbsd
else
    os = linux
endif

android := 0

ifeq ($(android), 1)
	os = android
	cc = arm-linux-androideabi-gcc
	cxx = arm-linux-androideabi-g++
	ar = arm-linux-androideabi-ar
else ifeq ($(os), windows)
	cc = gcc
	cxx = g++
	ar = ar
else ifeq ($(os), macosx)
	cc = gcc
	cxx = g++
	ar = ar
else
	cc = $(CC)
	cxx = $(CXX)
	ar = $(AR)
endif

arch :=
debug := 0
noflags := 0

cppflags = $(CXXFLAGS)
cflags = -std=c99 -Iinclude -Isrc/lua `sdl-config --cflags` \
		`pkg-config --cflags glib-2.0 gthread-2.0 libpng` \
		`pkg-config --cflags freetype2` \
		$(CFLAGS) -D_FILE_OFFSET_BITS=64
objects = obj/emu_emu.o obj/emu_video.o obj/emu_audio_openal.o \
		obj/emu_audio_common.o obj/emu_audio_dummy.o obj/emu_audio_sdl.o \
		obj/emu_audio_debug.o obj/emu_input.o \
		obj/emu_menu.o obj/emu_texture.o obj/emu_font.o \
		obj/emu_render.o obj/emu_dialog.o obj/emu_hud.o obj/emu_actions.o \
		obj/emu_xml_shader.o obj/emu_util.o obj/emu_netplay.o \
		obj/emu_scanlines.o obj/emu_theme.o obj/emu_video_buffer.o \
		obj/emu_video_options.o obj/emu_audio_dummy.o \
		obj/emu_emu_lua.o \
		\
		obj/ml_ml.o obj/ml_windows.o obj/ml_render.o \
		obj/ml_sdl.o obj/ml_rawinput.o obj/ml_macosx.o obj/ml_x11.o \
		\
		obj/base.o obj/log.o obj/config.o obj/image.o obj/ref.o \
		obj/glee.o obj/opengl.o obj/thread.o obj/string.o obj/filesys.o \
		obj/unicode.o obj/init.o obj/random.o obj/list.o obj/eventlog.o \
		obj/queue.o obj/hashtable.o obj/inifile.o obj/time.o \
		obj/lua_lapi.o \
		obj/lua_lauxlib.o \
		obj/lua_lbaselib.o \
		obj/lua_lbitlib.o \
		obj/lua_lcode.o \
		obj/lua_lcorolib.o \
		obj/lua_lctype.o \
		obj/lua_ldblib.o \
		obj/lua_ldebug.o \
		obj/lua_ldo.o \
		obj/lua_ldump.o \
		obj/lua_lfunc.o \
		obj/lua_lgc.o \
		obj/lua_linit.o \
		obj/lua_liolib.o \
		obj/lua_llex.o \
		obj/lua_lmathlib.o \
		obj/lua_lmem.o \
		obj/lua_loadlib.o \
		obj/lua_lobject.o \
		obj/lua_lopcodes.o \
		obj/lua_loslib.o \
		obj/lua_lparser.o \
		obj/lua_lstate.o \
		obj/lua_lstring.o \
		obj/lua_lstrlib.o \
		obj/lua_ltable.o \
		obj/lua_ltablib.o \
		obj/lua_ltm.o \
		obj/lua_lundump.o \
		obj/lua_lvm.o \
		obj/lua_lzio.o

ldflags = $(LDFLAGS)
libs =
ifeq ($(force_32bit),1)
    cflags += -m32
    ldflags += -m32
endif

ifeq ($(devel), 1)
	cflags += -Wall -Wno-deprecated-declarations
	cflags += -Werror -Wno-error=unused-function
	#-Werror=implicit-function-declaration
endif

ifeq ($(debug), 1)
	cflags += -g -O0 -fno-inline
else ifneq ($(noflags), 1)
	cflags += -g -O2
endif

ifeq ($(os), windows)
	cppflags += -DWINDOWS -DWIN32
	cppflags += -DUSE_SDL
	cppflags += -DUSE_PNG
	cppflags += -DUSE_GLIB
	cppflags += -DUSE_SDL_VIDEO
	cppflags += -DUSE_OPENGL
	#cppflags += -DUSE_SDL_INPUT
	cppflags += -DUSE_OPENAL
	cppflags += -DUSE_FREETYPE
	library = libfsemu.a

else ifeq ($(android), 1)
	cppflags += -DANDROID
	cppflags += -DUSE_OPENGL
	cppflags += -DUSE_GLES
	cppflags += -DUSE_PTHREADS
	library = libfsemu.a

else ifeq ($(os), macosx)
	uname_m := $(shell uname -m)
	ifneq ($(arch),)
	else ifneq ($(findstring i386,$(uname_m)),)
	arch = i386
	else ifneq ($(findstring Power,$(uname_m)),)
	arch = ppc
	else
	arch = x86_64
	endif
	cflags += -arch $(arch)
	cxxflags += -arch $(arch)
	ldflags += -arch $(arch)
	cppflags += -DMACOSX
	cppflags += -I/System/Library/Frameworks/OpenAL.framework/Headers
	cppflags += -DUSE_SDL
	cppflags += -DUSE_PNG
	cppflags += -DUSE_GLIB
	cppflags += -DUSE_SDL_VIDEO
	cppflags += -DUSE_OPENGL
	cppflags += -DUSE_SDL_INPUT
	cppflags += -DUSE_OPENAL
	cppflags += -DUSE_FREETYPE
	library = libfsemu.a

else
	ifeq ($(os), linux)
		cppflags += -DLINUX
	else ifeq ($(os), freebsd)
		cppflags += -DFREEBSD
	else ifeq ($(os), openbsd)
		cppflags += -DOPENBSD
	endif
	cppflags += -DUSE_SDL
	cppflags += -DUSE_PNG
	cppflags += -DUSE_GLIB
	cppflags += -DUSE_X11
	cppflags += -DUSE_SDL_VIDEO
	cppflags += -DUSE_OPENGL
	cppflags += -DUSE_SDL_INPUT
	cppflags += -DUSE_OPENAL
	cppflags += -DUSE_FREETYPE
	library = libfsemu.a
	shared = libfsemu.so.1.0
	shared_soname = libfsemu.so.1
	shared_linkname = libfsemu.so
	shared_ldflags += -shared -Wl,--as-needed -Wl,-soname=$(library_soname)

endif

ifeq ($(os), android)
else
	cppflags += -DWITH_NETPLAY -DWITH_XML_SHADER -DWITH_LUA
	#cppflags += -DWITH_NETPLAY -DUSE_GLES -DFAKE_GLES
endif

all: libfsemu

libfsemu: out/$(library)

obj/%.o: src/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

obj/emu_%.o: src/emu/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

obj/ml_%.o: src/ml/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

obj/lua_%.o: src/lua/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

out/$(library): $(objects)
ifeq ($(os), macosx)
	rm -f $@
endif
	$(ar) cru $@ $(objects)
ifeq ($(os), macosx)
	ranlib $@
endif

out/$(shared): $(objects)
	$(cc) $(shared_ldflags) $(objects) $(libs) -o $@

fs-test:
	make -C test

clean:
	rm -f obj/*.o
	rm -f out/*.a
	rm -f out/*.so*
	#make -C test clean

prefix := /usr

install:
	mkdir -p $(DESTDIR)$(prefix)/include
	cp -a include/* $(DESTDIR)$(prefix)/include/
	mkdir -p $(DESTDIR)$(prefix)/lib
	cp -a out/$(shared) $(DESTDIR)$(prefix)/lib/
	cp -a out/$(library) $(DESTDIR)$(prefix)/lib/
	ln -s $(shared) $(DESTDIR)$(prefix)/lib/$(shared_linkname)
	mkdir -p $(DESTDIR)$(prefix)/lib/pkgconfig/
	cp -a *.pc $(DESTDIR)$(prefix)/lib/pkgconfig/

=== macosx/Makefile ===
include ../common.mk
version = $(strip $(shell cat ../VERSION))

bindist: bundle
	python fix-app.py
	cp -pPR ../licenses fs-uae-$(version)-macosx/
	cp ../COPYING fs-uae-$(version)-macosx/
	cp ../README fs-uae-$(version)-macosx/
	cp ../example.conf fs-uae-$(version)-macosx/
	GZIP=-9 tar zcfv fs-uae-$(version)-macosx.tar.gz fs-uae-$(version)-macosx

bundle:
	make -C ..
	rm -Rf fs-uae-$(version)-macosx
	mkdir -p fs-uae-$(version)-macosx
	mkdir -p fs-uae-$(version)-macosx/FS-UAE.app/Contents/Frameworks
	mkdir -p fs-uae-$(version)-macosx/FS-UAE.app/Contents/MacOS
	mkdir -p fs-uae-$(version)-macosx/FS-UAE.app/Contents/Resources
	cp -pPR template/* fs-uae-$(version)-macosx/FS-UAE.app/
	cp ../fs-uae fs-uae-$(version)-macosx/FS-UAE.app/Contents/MacOS
	cp ../../libfs-capsimage.dylib fs-uae-$(version)-macosx/FS-UAE.app/Contents/Frameworks || cp ../libfs-capsimage.dylib fs-uae-$(version)-macosx/FS-UAE.app/Contents/Frameworks
	cp -pPR ../share/* fs-uae-$(version)-macosx/FS-UAE.app/Contents/Resources
	strip fs-uae-$(version)-macosx/FS-UAE.app/Contents/MacOS/*
	#strip fs-uae-$(version)-macosx/FS-UAE.app/Contents/Frameworks/*
	cp ../icon/fs-uae.icns fs-uae-$(version)-macosx/FS-UAE.app/Contents/Resources/
	cp ../icon/fs-uae-config.icns fs-uae-$(version)-macosx/FS-UAE.app/Contents/Resources/

launcher:
	make -C ../launcher -f Makefile.mk
	mkdir -p fs-uae-$(version)-macosx
	cd ../launcher && python2.7 setup_py2app.py py2app --iconfile ../icon/fs-uae-launcher.icns
	mv ../launcher/dist/"FS-UAE Launcher.app" fs-uae-$(version)-macosx/
	cp -pPR ../launcher/share/* fs-uae-$(version)-macosx/"FS-UAE Launcher.app"/Contents/Resources

bindist-plus:
	GZIP=-9 tar zcfv fs-uae-plus-$(version)-macosx.tar.gz fs-uae-$(version)-macosx

=== windows/Makefile ===
include ../common.mk
version = $(strip $(shell cat ../VERSION))

bindist: program
	cp -a ../licenses fs-uae-$(version)-windows/
	cp -a ../README fs-uae-$(version)-windows/README.txt
	cp -a ../COPYING fs-uae-$(version)-windows/COPYING.txt
	cp -a ../example.conf fs-uae-$(version)-windows
	zip -9 -r fs-uae-$(version)-windows.zip fs-uae-$(version)-windows

program:
	make -C ..
	rm -Rf fs-uae-$(version)-windows
	mkdir fs-uae-$(version)-windows
	cp /mingw/bin/zlib1.dll fs-uae-$(version)-windows
	cp /mingw/bin/libglib-2.0-0.dll fs-uae-$(version)-windows
	cp /mingw/bin/libgthread-2.0-0.dll fs-uae-$(version)-windows
	cp /mingw/bin/intl.dll fs-uae-$(version)-windows
	cp /mingw/bin/libpng*.dll fs-uae-$(version)-windows
	cp /mingw/bin/*freetype*.dll fs-uae-$(version)-windows
	cp /mingw/bin/libgcc_s_*.dll fs-uae-$(version)-windows
	cp /mingw/bin/libstdc++*.dll fs-uae-$(version)-windows
	cp /mingw/bin/libintl*.dll fs-uae-$(version)-windows
	cp /mingw/bin/libiconv*.dll fs-uae-$(version)-windows
	cp /mingw/bin/SDL.dll fs-uae-$(version)-windows
	cp /mingw/bin/OpenAL32.dll fs-uae-$(version)-windows
	cp -a ../fs-uae.exe fs-uae-$(version)-windows/fs-uae.exe
	cp -a ../../CAPSImg.dll fs-uae-$(version)-windows || cp -a ../CAPSImg.dll fs-uae-$(version)-windows
	cp -a ../share fs-uae-$(version)-windows
	strip fs-uae-$(version)-windows/*.exe
	strip fs-uae-$(version)-windows/*.dll
	python /c/signtool.py fs-uae-$(version)-windows/*.exe

launcher:
	make -C ../launcher -f Makefile.mk
	rm -Rf ../launcher/dist
	cd ../launcher && python setup_py2exe.py py2exe
	rm -Rf fs-uae-$(version)-windows/launcher
	mv ../launcher/dist fs-uae-$(version)-windows/launcher
	cp -a ../launcher/share fs-uae-$(version)-windows/launcher/
	mv fs-uae-$(version)-windows/launcher/fs-uae-launcher.exe "fs-uae-$(version)-windows/launcher/FS-UAE Launcher.exe"
	python replace_icon.py "fs-uae-$(version)-windows/launcher/FS-UAE Launcher.exe" ../icon/fs-uae-launcher.ico
	python /c/signtool.py "fs-uae-$(version)-windows/launcher/FS-UAE Launcher.exe"
	cp -a /mingw/Microsoft.VC90.CRT fs-uae-$(version)-windows/launcher/

bindist-plus:
	zip -9 -r fs-uae-plus-$(version)-windows.zip fs-uae-$(version)-windows

setup:
	iscc fs-uae-setup.iss
	python /c/signtool.py fs-uae-$(version)-setup.exe

=== debian/changelog ===
fs-uae (2.2.3+dfsg-4ubuntu1) trusty; urgency=low

  * Add build-dependancy on libfreetype6-dev. Fixes FTBFS

 -- Jackson Doak <noskcaj@ubuntu.com>  Sun, 10 Nov 2013 06:26:22 +1100

fs-uae (2.2.3+dfsg-4) unstable; urgency=low

  * Update Debian JIT compiler disable patch to include
    kFreeBSD/i386 since the JIT doesn't build here either.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 05 Nov 2013 23:43:28 +0100

fs-uae (2.2.3+dfsg-3) unstable; urgency=low

  * Enable version mangling for debian/watch file.
  * Add Debian patch to enable build support for kFreeBSD.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 05 Nov 2013 22:33:47 +0100

fs-uae (2.2.3+dfsg-2) unstable; urgency=low

  * Remove entry for src/core.cw4.cpp in debian/copyright.
  * Fix formatting for email address for src/cdrom-handler.cpp entry
    in debian/copyright.
  * Add comment with source code reference for src/hrtmon.rom.cpp
    in debian/copyright.
  * Add comment with source code reference for src/cdrom-handler.cpp
    in debian/copyright.
  * Add Debian patch to disable the JIT compiler on anything but i386.
  * Add Debian patch to provide generic access functions to the virtual
    Amiga's memory to support architectures other than x86, PPC and ARMEL.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 05 Nov 2013 00:19:26 +0100

fs-uae (2.2.3+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #680899)

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Fri, 01 Nov 2013 14:33:54 +0100

=== debian/control ===
Source: fs-uae
Section: otherosfs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
Build-Depends: debhelper (>= 9), libsdl1.2-dev, libglib2.0-dev, libopenal-dev, gettext, python (>= 2.6), python-setuptools, glee-dev, libfreetype6-dev
Standards-Version: 3.9.4
Homepage: http://fs-uae.net
Vcs-Git: git://github.com/glaubitz/fs-uae-debian.git
Vcs-Browser: https://github.com/glaubitz/fs-uae-debian

Package: fs-uae
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cross-platform Amiga emulator based on UAE/WinUAE
 FS-UAE is a cross-platform Amiga emulator based on updated emulation code
 from WinUAE. FS-UAE uses SDL for input, OpenAL for audio and OpenGL
 for graphics.

Package: fs-uae-launcher
Architecture: all
Depends: python (>= 2.6), ${misc:Depends}, fs-uae, python-pygame, python-wxgtk2.8, python-setuptools
Description: Launcher and configuration program for FS-UAE
 FS-UAE is a cross-platform Amiga emulator based on updated emulation code
 from WinUAE. FS-UAE uses SDL for input, OpenAL for audio and OpenGL
 for graphics.
 .
 This package contains the launcher, a graphical user interface for
 setting up FS-UAE.

Package: fs-uae-netplay-server
Architecture: all
Depends: python (>= 2.6), ${misc:Depends}, adduser (>= 3.11)
Description: Netplay server for FS-UAE online play
 FS-UAE is a cross-platform Amiga emulator based on updated emulation code
 from WinUAE. FS-UAE uses SDL for input, OpenAL for audio and OpenGL
 for graphics.
 .
 This package contains the FS-UAE netplay game server, and a service
 to start game servers on demand.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --sourcedirectory=launcher
	make -C launcher -f Makefile.mk

override_dh_auto_install:
	make install prefix=$$(pwd)/debian/fs-uae/usr
	make -C launcher -f Makefile.mk install prefix=$$(pwd)/debian/fs-uae-launcher/usr
	cd launcher && python setup.py install --no-compile --install-layout=deb --root=../debian/fs-uae-launcher --install-lib=/usr/share/fs-uae-launcher --install-scripts=/usr/share/fs-uae-launcher
	cd server && python setup.py install --no-compile --install-layout=deb --root=../debian/fs-uae-netplay-server --install-lib=/usr/share/fs-uae-netplay-server --install-scripts=/usr/share/fs-uae-netplay-server

%:
	dh $@
